Yandex Cloud
Search
Discuss with expertTry it for free
  • Customer Stories
  • Documentation
  • Blog
  • All Services
  • System Status
  • Marketplace
    • Featured
    • Infrastructure & Network
    • Data Platform
    • AI for business
    • Security
    • DevOps tools
    • Serverless
    • Monitoring & Resources
  • All Solutions
    • By industry
    • By use case
    • Economics and Pricing
    • Security
    • Technical Support
    • Start testing with double trial credits
    • Cloud credits to scale your IT product
    • Gateway to Russia
    • Cloud for Startups
    • Center for Technologies and Society
    • Yandex Cloud Partner program
    • Price calculator
    • Pricing plans
  • Customer Stories
  • Documentation
  • Blog
© 2026 Direct Cursus Technology L.L.C.
Yandex Virtual Private Cloud
  • Getting started
  • DDoS Protection
  • Access management
  • Pricing policy
  • Terraform reference
    • API authentication
      • Overview
        • Overview
          • Overview
          • Get
          • List
          • Create
          • Update
          • Delete
          • ListOperations
  • Audit Trails events
  • Release notes
  • FAQ

In this article:

  • HTTP request
  • Body parameters
  • AddressSpec
  • InternalIpv4AddressSpec
  • DnsOptions
  • Response
  • Status
  1. API reference
  2. REST
  3. Virtual Private Cloud API
  4. PrivateEndpoint
  5. Create

Virtual Private Cloud API, REST: PrivateEndpoint.Create

Written by
Yandex Cloud
Updated at June 18, 2026
  • HTTP request
  • Body parameters
  • AddressSpec
  • InternalIpv4AddressSpec
  • DnsOptions
  • Response
  • Status

Creates an private endpoint in the specified folder and network.

HTTP requestHTTP request

POST https://vpc.api.cloud.yandex.net/vpc/v1/endpoints

Body parametersBody parameters

{
  "folderId": "string",
  "name": "string",
  "description": "string",
  "labels": "object",
  "networkId": "string",
  "addressSpec": {
    // Includes only one of the fields `addressId`, `internalIpv4AddressSpec`
    "addressId": "string",
    "internalIpv4AddressSpec": {
      "subnetId": "string",
      "address": "string"
    }
    // end of the list of possible fields
  },
  "dnsOptions": {
    "privateDnsRecordsEnabled": "boolean"
  },
  // Includes only one of the fields `objectStorage`, `serviceName`
  "objectStorage": "object",
  "serviceName": "string"
  // end of the list of possible fields
}

Field

Description

folderId

string

ID of the folder to create a private endpoint in.
To get a folder ID make a
yandex.cloud.resourcemanager.v1.FolderService.List request.
The length must be less than or equal to 50.
This field is required.

name

string

Name of the private endpoint.
The name must be unique within the folder.
The value must match the regular expression: |[a-z]([-a-z0-9]{0,61}[a-z0-9])?.

description

string

Description of the private endpoint.
The length must be less than or equal to 256.

labels

object (map<string, string>)

Private endpoint labels as key:value pairs.
Each map key must match the regular expression: [a-z][-_./\\@0-9a-z]*.
Each map value must match the regular expression: [-_./\\@0-9a-z]*.
The length of each map key must be between 1 and 63.
The length of each map value must be less than or equal to 63.
The number of elements must be less than or equal to 64.

networkId

string

ID of the network to create a private endpoint in.
The length must be less than or equal to 50.
This field is required.

addressSpec

AddressSpec

Private endpoint address specification.

dnsOptions

DnsOptions

Private endpoint dns options.

objectStorage

object

Yandex Cloud Object Storage.

Includes only one of the fields objectStorage, serviceName.

Service to connect with via private endpoint.
Only one field must be specified.

serviceName

string

Yandex Cloud service name.

Includes only one of the fields objectStorage, serviceName.

Service to connect with via private endpoint.
Only one field must be specified.

AddressSpecAddressSpec

Field

Description

addressId

string

ID of IP address to associate with private endpoint.

Includes only one of the fields addressId, internalIpv4AddressSpec.

internalIpv4AddressSpec

InternalIpv4AddressSpec

Internal ipv4 address specification.

Includes only one of the fields addressId, internalIpv4AddressSpec.

InternalIpv4AddressSpecInternalIpv4AddressSpec

Field

Description

subnetId

string

ID of the subnet that address belongs to.
The length must be less than or equal to 50.
This field is required.

address

string

Value of address.

DnsOptionsDnsOptions

Field

Description

privateDnsRecordsEnabled

boolean

If enabled - vpc will create private dns records for specified service.

ResponseResponse

HTTP Code: 200 - OK

{
  "id": "string",
  "description": "string",
  "createdAt": "string",
  "createdBy": "string",
  "modifiedAt": "string",
  "done": "boolean",
  "metadata": "object",
  // Includes only one of the fields `error`, `response`
  "error": {
    "code": "integer",
    "message": "string",
    "details": [
      "object"
    ]
  },
  "response": "object"
  // end of the list of possible fields
}

An Operation resource. For more information, see Operation.

Field

Description

id

string

ID of the operation.

description

string

Description of the operation. 0-256 characters long.

createdAt

string (date-time)

Creation timestamp.

String in RFC3339 text format. The range of possible values is from
0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
Protocol Buffers reference.
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits).

createdBy

string

ID of the user or service account who initiated the operation.

modifiedAt

string (date-time)

The time when the Operation resource was last modified.

String in RFC3339 text format. The range of possible values is from
0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
Protocol Buffers reference.
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits).

done

boolean

If the value is false, it means the operation is still in progress.
If true, the operation is completed, and either error or response is available.

metadata

object

Service-specific metadata associated with the operation.
It typically contains the ID of the target resource that the operation is performed on.
Any method that returns a long-running operation should document the metadata type, if any.

error

Status

The error result of the operation in case of failure or cancellation.

Includes only one of the fields error, response.

The operation result.
If done == false and there was no failure detected, neither error nor response is set.
If done == false and there was a failure detected, error is set.
If done == true, exactly one of error or response is set.

response

object

The normal response of the operation in case of success.
If the original method returns no data on success, such as Delete,
the response is google.protobuf.Empty.
If the original method is the standard Create/Update,
the response should be the target resource of the operation.
Any method that returns a long-running operation should document the response type, if any.

Includes only one of the fields error, response.

The operation result.
If done == false and there was no failure detected, neither error nor response is set.
If done == false and there was a failure detected, error is set.
If done == true, exactly one of error or response is set.

StatusStatus

The error result of the operation in case of failure or cancellation.

Field

Description

code

integer (int32)

Error code. An enum value of google.rpc.Code.

message

string

An error message.

details[]

object

A list of messages that carry the error details.

Was the article helpful?

Previous
List
Next
Update
© 2026 Direct Cursus Technology L.L.C.